Index: drivers/filesystems/btrfs/fsctl.c
===================================================================
--- drivers/filesystems/btrfs/fsctl.c	(révision 74430)
+++ drivers/filesystems/btrfs/fsctl.c	(copie de travail)
@@ -1,4 +1,4 @@
-/* Copyright (c) Mark Harmstone 2016
+/* Copyright (c) Mark Harmstone 2016-17
  * 
  * This file is part of WinBtrfs.
  * 
@@ -17,9 +17,8 @@
 
 #include "btrfs_drv.h"
 #include "btrfsioctl.h"
-#ifndef __REACTOS__
-#include <winioctl.h>
-#endif
+#include <ntddstor.h>
+#include <ntdddisk.h>
 
 #ifndef FSCTL_CSV_CONTROL
 #define FSCTL_CSV_CONTROL CTL_CODE(FILE_DEVICE_FILE_SYSTEM, 181, METHOD_BUFFERED, FILE_ANY_ACCESS)
@@ -29,10 +28,13 @@
 
 #define SEF_AVOID_PRIVILEGE_CHECK 0x08 // on MSDN but not in any header files(?)
 
+#ifndef _MSC_VER // not in mingw yet
+#define DEVICE_DSM_FLAG_TRIM_NOT_FS_ALLOCATED 0x80000000
+#endif
+
 extern LIST_ENTRY VcbList;
 extern ERESOURCE global_loading_lock;
-extern LIST_ENTRY volumes;
-extern ERESOURCE volumes_lock;
+extern PDRIVER_OBJECT drvobj;
 
 static NTSTATUS get_file_ids(PFILE_OBJECT FileObject, void* data, ULONG length) {
     btrfs_get_file_ids* bgfi;
@@ -75,7 +77,7 @@
 static NTSTATUS snapshot_tree_copy(device_extension* Vcb, UINT64 addr, root* subvol, UINT64* newaddr, PIRP Irp, LIST_ENTRY* rollback) {
     UINT8* buf;
     NTSTATUS Status;
-    write_data_context* wtc;
+    write_data_context wtc;
     LIST_ENTRY* le;
     tree t;
     tree_header* th;
@@ -87,14 +89,10 @@
         return STATUS_INSUFFICIENT_RESOURCES;
     }
     
-    wtc = ExAllocatePoolWithTag(NonPagedPool, sizeof(write_data_context), ALLOC_TAG);
-    if (!wtc) {
-        ERR("out of memory\n");
-        ExFreePool(buf);
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
+    wtc.parity1 = wtc.parity2 = wtc.scratch = NULL;
+    wtc.mdl = wtc.parity1_mdl = wtc.parity2_mdl = NULL;
     
-    Status = read_data(Vcb, addr, Vcb->superblock.node_size, NULL, TRUE, buf, NULL, NULL, Irp, FALSE);
+    Status = read_data(Vcb, addr, Vcb->superblock.node_size, NULL, TRUE, buf, NULL, NULL, Irp, 0, FALSE, 0);
     if (!NT_SUCCESS(Status)) {
         ERR("read_data returned %08x\n", Status);
         goto end;
@@ -121,9 +119,9 @@
     
     c = get_chunk_from_address(Vcb, t.new_address);
             
-    if (c) {
-        increase_chunk_usage(c, Vcb->superblock.node_size);
-    } else {
+    if (c)
+        c->used += Vcb->superblock.node_size;
+    else {
         ERR("could not find chunk for address %llx\n", t.new_address);
         Status = STATUS_INTERNAL_ERROR;
         goto end;
@@ -146,7 +144,7 @@
                     EXTENT_DATA2* ed2 = (EXTENT_DATA2*)&ed->data[0];
                     
                     if (ed2->size != 0) { // not sparse
-                        Status = increase_extent_refcount_data(Vcb, ed2->address, ed2->size, subvol->id, ln[i].key.obj_id, ln[i].key.offset - ed2->offset, 1, Irp, rollback);
+                        Status = increase_extent_refcount_data(Vcb, ed2->address, ed2->size, subvol->id, ln[i].key.obj_id, ln[i].key.offset - ed2->offset, 1, Irp);
                         
                         if (!NT_SUCCESS(Status)) {
                             ERR("increase_extent_refcount_data returned %08x\n", Status);
@@ -165,7 +163,7 @@
             
             tbr.offset = subvol->id;
             
-            Status = increase_extent_refcount(Vcb, in[i].address, Vcb->superblock.node_size, TYPE_TREE_BLOCK_REF, &tbr, NULL, th->level - 1, Irp, rollback);
+            Status = increase_extent_refcount(Vcb, in[i].address, Vcb->superblock.node_size, TYPE_TREE_BLOCK_REF, &tbr, NULL, th->level - 1, Irp);
             if (!NT_SUCCESS(Status)) {
                 ERR("increase_extent_refcount returned %08x\n", Status);
                 goto end;
@@ -175,21 +173,21 @@
     
     *((UINT32*)buf) = ~calc_crc32c(0xffffffff, (UINT8*)&th->fs_uuid, Vcb->superblock.node_size - sizeof(th->csum));
     
-    KeInitializeEvent(&wtc->Event, NotificationEvent, FALSE);
-    InitializeListHead(&wtc->stripes);
-    wtc->tree = TRUE;
-    wtc->stripes_left = 0;
+    KeInitializeEvent(&wtc.Event, NotificationEvent, FALSE);
+    InitializeListHead(&wtc.stripes);
+    wtc.tree = TRUE;
+    wtc.stripes_left = 0;
     
-    Status = write_data(Vcb, t.new_address, buf, FALSE, Vcb->superblock.node_size, wtc, NULL, NULL);
+    Status = write_data(Vcb, t.new_address, buf, Vcb->superblock.node_size, &wtc, NULL, NULL, FALSE, 0);
     if (!NT_SUCCESS(Status)) {
         ERR("write_data returned %08x\n", Status);
         goto end;
     }
     
-    if (wtc->stripes.Flink != &wtc->stripes) {
+    if (wtc.stripes.Flink != &wtc.stripes) {
         // launch writes and wait
-        le = wtc->stripes.Flink;
-        while (le != &wtc->stripes) {
+        le = wtc.stripes.Flink;
+        while (le != &wtc.stripes) {
             write_data_stripe* stripe = CONTAINING_RECORD(le, write_data_stripe, list_entry);
             
             if (stripe->status != WriteDataStatus_Ignore)
@@ -198,14 +196,15 @@
             le = le->Flink;
         }
         
-        KeWaitForSingleObject(&wtc->Event, Executive, KernelMode, FALSE, NULL);
+        KeWaitForSingleObject(&wtc.Event, Executive, KernelMode, FALSE, NULL);
         
-        le = wtc->stripes.Flink;
-        while (le != &wtc->stripes) {
+        le = wtc.stripes.Flink;
+        while (le != &wtc.stripes) {
             write_data_stripe* stripe = CONTAINING_RECORD(le, write_data_stripe, list_entry);
             
             if (stripe->status != WriteDataStatus_Ignore && !NT_SUCCESS(stripe->iosb.Status)) {
                 Status = stripe->iosb.Status;
+                log_device_error(Vcb, stripe->device, BTRFS_DEV_STAT_WRITE_ERRORS);
                 break;
             }
             
@@ -212,7 +211,7 @@
             le = le->Flink;
         }
         
-        free_write_data_stripes(wtc);
+        free_write_data_stripes(&wtc);
         buf = NULL;
     }
     
@@ -220,7 +219,6 @@
         *newaddr = t.new_address;
     
 end:
-    ExFreePool(wtc);
     
     if (buf)
         ExFreePool(buf);
@@ -228,7 +226,7 @@
     return Status;
 }
 
-static void flush_subvol_fcbs(root* subvol, LIST_ENTRY* rollback) {
+static void flush_subvol_fcbs(root* subvol) {
     LIST_ENTRY* le = subvol->fcbs.Flink;
     
     if (IsListEmpty(&subvol->fcbs))
@@ -252,7 +250,7 @@
     root *r, *subvol = subvol_fcb->subvol;
     KEY searchkey;
     traverse_ptr tp;
-    UINT64 address, dirpos, *root_num;
+    UINT64 address, *root_num;
     LARGE_INTEGER time;
     BTRFS_TIME now;
     fcb* fcb = parent->FsContext;
@@ -273,20 +271,23 @@
     
     fileref = ccb->fileref;
     
-    InitializeListHead(&rollback);
-    
     // flush open files on this subvol
     
-    flush_subvol_fcbs(subvol, &rollback);
+    flush_subvol_fcbs(subvol);
 
     // flush metadata
     
     if (Vcb->need_write)
-        do_write(Vcb, Irp, &rollback);
+        Status = do_write(Vcb, Irp);
+    else
+        Status = STATUS_SUCCESS;
     
     free_trees(Vcb);
     
-    clear_rollback(Vcb, &rollback);
+    if (!NT_SUCCESS(Status)) {
+        ERR("do_write returned %08x\n", Status);
+        return Status;
+    }
     
     InitializeListHead(&rollback);
     
@@ -293,7 +294,7 @@
     // create new root
     
     id = InterlockedIncrement64(&Vcb->root_root->lastinode);
-    Status = create_root(Vcb, id, &r, TRUE, Vcb->superblock.generation, Irp, &rollback);
+    Status = create_root(Vcb, id, &r, TRUE, Vcb->superblock.generation, Irp);
     
     if (!NT_SUCCESS(Status)) {
         ERR("create_root returned %08x\n", Status);
@@ -307,7 +308,7 @@
         
         TRACE("uuid root doesn't exist, creating it\n");
         
-        Status = create_root(Vcb, BTRFS_ROOT_UUID, &uuid_root, FALSE, 0, Irp, &rollback);
+        Status = create_root(Vcb, BTRFS_ROOT_UUID, &uuid_root, FALSE, 0, Irp);
         
         if (!NT_SUCCESS(Status)) {
             ERR("create_root returned %08x\n", Status);
@@ -338,10 +339,10 @@
     
     *root_num = r->id;
     
-    if (!insert_tree_item(Vcb, Vcb->uuid_root, searchkey.obj_id, searchkey.obj_type, searchkey.offset, root_num, sizeof(UINT64), NULL, Irp, &rollback)) {
-        ERR("insert_tree_item failed\n");
+    Status = insert_tree_item(Vcb, Vcb->uuid_root, searchkey.obj_id, searchkey.obj_type, searchkey.offset, root_num, sizeof(UINT64), NULL, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
         ExFreePool(root_num);
-        Status = STATUS_INTERNAL_ERROR;
         goto end;
     }
     
@@ -414,7 +415,7 @@
     
     // create fileref for entry in other subvolume
     
-    fr = create_fileref();
+    fr = create_fileref(Vcb);
     if (!fr) {
         ERR("out of memory\n");
         Status = STATUS_INSUFFICIENT_RESOURCES;
@@ -421,55 +422,16 @@
         goto end;
     }
     
-    fr->utf8.Length = fr->utf8.MaximumLength = utf8->Length;
-    fr->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, fr->utf8.MaximumLength, ALLOC_TAG);
-    if (!fr->utf8.Buffer) {
-        ERR("out of memory\n");
-        free_fileref(fr);
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end;
-    }
-    
-    RtlCopyMemory(fr->utf8.Buffer, utf8->Buffer, utf8->Length);
-    
     Status = open_fcb(Vcb, r, r->root_item.objid, BTRFS_TYPE_DIRECTORY, utf8, fcb, &fr->fcb, PagedPool, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("open_fcb returned %08x\n", Status);
-        free_fileref(fr);
+        free_fileref(Vcb, fr);
         goto end;
     }
     
-    Status = fcb_get_last_dir_index(fcb, &dirpos, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("fcb_get_last_dir_index returned %08x\n", Status);
-        free_fileref(fr);
-        goto end;
-    }
-    
-    fr->index = dirpos;
-    
-    fr->filepart.MaximumLength = fr->filepart.Length = name->Length;
-    
-    fr->filepart.Buffer = ExAllocatePoolWithTag(PagedPool, fr->filepart.MaximumLength, ALLOC_TAG);
-    if (!fr->filepart.Buffer) {
-        ERR("out of memory\n");
-        free_fileref(fr);
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end;
-    }
-    
-    RtlCopyMemory(fr->filepart.Buffer, name->Buffer, name->Length);
-    
-    Status = RtlUpcaseUnicodeString(&fr->filepart_uc, &fr->filepart, TRUE);
-    if (!NT_SUCCESS(Status)) {
-        ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-        free_fileref(fr);
-        goto end;
-    }
-    
     fr->parent = fileref;
     
-    Status = add_dir_child(fileref->fcb, r->id, TRUE, dirpos, utf8, &fr->filepart, &fr->filepart_uc, BTRFS_TYPE_DIRECTORY, &dc);
+    Status = add_dir_child(fileref->fcb, r->id, TRUE, utf8, name, BTRFS_TYPE_DIRECTORY, &dc);
     if (!NT_SUCCESS(Status))
         WARN("add_dir_child returned %08x\n", Status);
     
@@ -476,7 +438,10 @@
     fr->dc = dc;
     dc->fileref = fr;
     
-    insert_fileref_child(fileref, fr, TRUE);
+    ExAcquireResourceExclusiveLite(&fileref->nonpaged->children_lock, TRUE);
+    InsertTailList(&fileref->children, &fr->list_entry);
+    ExReleaseResourceLite(&fileref->nonpaged->children_lock);
+    
     increase_fileref_refcount(fileref);
     
     fr->created = TRUE;
@@ -485,7 +450,7 @@
     if (fr->fcb->type == BTRFS_TYPE_DIRECTORY)
         fr->fcb->fileref = fr;
     
-    free_fileref(fr);
+    free_fileref(Vcb, fr);
 
     // change fcb's INODE_ITEM
     
@@ -525,15 +490,16 @@
         le = le->Flink;
     }
     
-    do_write(Vcb, Irp, &rollback);
+    Status = do_write(Vcb, Irp);
     
     free_trees(Vcb);
     
-    Status = STATUS_SUCCESS;
+    if (!NT_SUCCESS(Status))
+        ERR("do_write returned %08x\n", Status);
     
 end:
     if (NT_SUCCESS(Status))
-        clear_rollback(Vcb, &rollback);
+        clear_rollback(&rollback);
     else
         do_rollback(Vcb, &rollback);
 
@@ -626,11 +592,11 @@
     if (NT_SUCCESS(Status)) {
         if (!fr2->deleted) {
             WARN("file already exists\n");
-            free_fileref(fr2);
+            free_fileref(Vcb, fr2);
             Status = STATUS_OBJECT_NAME_COLLISION;
             goto end3;
         } else
-            free_fileref(fr2);
+            free_fileref(Vcb, fr2);
     } else if (!NT_SUCCESS(Status) && Status != STATUS_OBJECT_NAME_NOT_FOUND) {
         ERR("open_fileref returned %08x\n", Status);
         goto end3;
@@ -701,7 +667,7 @@
             Status = STATUS_SUCCESS;
         } else {
             send_notification_fileref(fr, FILE_NOTIFY_CHANGE_DIR_NAME, FILE_ACTION_ADDED);
-            free_fileref(fr);
+            free_fileref(Vcb, fr);
         }
     }
     
@@ -718,11 +684,10 @@
 }
 
 static NTSTATUS create_subvol(device_extension* Vcb, PFILE_OBJECT FileObject, WCHAR* name, ULONG length, PIRP Irp) {
-    fcb *fcb, *rootfcb;
+    fcb *fcb, *rootfcb = NULL;
     ccb* ccb;
     file_ref* fileref;
     NTSTATUS Status;
-    LIST_ENTRY rollback;
     UINT64 id;
     root* r;
     LARGE_INTEGER time;
@@ -730,7 +695,6 @@
     ULONG len, irsize;
     UNICODE_STRING nameus;
     ANSI_STRING utf8;
-    UINT64 dirpos;
     INODE_REF* ir;
     KEY searchkey;
     traverse_ptr tp;
@@ -816,8 +780,6 @@
     KeQuerySystemTime(&time);
     win_time_to_unix(time, &now);
     
-    InitializeListHead(&rollback);
-    
     // no need for fcb_lock as we have tree_lock exclusively
     Status = open_fileref(fcb->Vcb, &fr2, &nameus, fileref, FALSE, NULL, NULL, PagedPool, FALSE, Irp);
     
@@ -824,20 +786,18 @@
     if (NT_SUCCESS(Status)) {
         if (!fr2->deleted) {
             WARN("file already exists\n");
-            free_fileref(fr2);
+            free_fileref(Vcb, fr2);
             Status = STATUS_OBJECT_NAME_COLLISION;
             goto end;
         } else
-            free_fileref(fr2);
+            free_fileref(Vcb, fr2);
     } else if (!NT_SUCCESS(Status) && Status != STATUS_OBJECT_NAME_NOT_FOUND) {
         ERR("open_fileref returned %08x\n", Status);
         goto end;
     }
     
-    // FIXME - make sure rollback removes new roots from internal structures
-    
     id = InterlockedIncrement64(&Vcb->root_root->lastinode);
-    Status = create_root(Vcb, id, &r, FALSE, 0, Irp, &rollback);
+    Status = create_root(Vcb, id, &r, FALSE, 0, Irp);
     
     if (!NT_SUCCESS(Status)) {
         ERR("create_root returned %08x\n", Status);
@@ -851,7 +811,7 @@
         
         TRACE("uuid root doesn't exist, creating it\n");
         
-        Status = create_root(Vcb, BTRFS_ROOT_UUID, &uuid_root, FALSE, 0, Irp, &rollback);
+        Status = create_root(Vcb, BTRFS_ROOT_UUID, &uuid_root, FALSE, 0, Irp);
         
         if (!NT_SUCCESS(Status)) {
             ERR("create_root returned %08x\n", Status);
@@ -882,9 +842,9 @@
     
     *root_num = r->id;
     
-    if (!insert_tree_item(Vcb, Vcb->uuid_root, searchkey.obj_id, searchkey.obj_type, searchkey.offset, root_num, sizeof(UINT64), NULL, Irp, &rollback)) {
-        ERR("insert_tree_item failed\n");
-        Status = STATUS_INTERNAL_ERROR;
+    Status = insert_tree_item(Vcb, Vcb->uuid_root, searchkey.obj_id, searchkey.obj_type, searchkey.offset, root_num, sizeof(UINT64), NULL, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
         goto end;
     }
     
@@ -904,7 +864,7 @@
     
     // add .. inode to new subvol
     
-    rootfcb = create_fcb(PagedPool);
+    rootfcb = create_fcb(Vcb, PagedPool);
     if (!rootfcb) {
         ERR("out of memory\n");
         Status = STATUS_INSUFFICIENT_RESOURCES;
@@ -924,7 +884,7 @@
     rootfcb->inode_item.st_atime = rootfcb->inode_item.st_ctime = rootfcb->inode_item.st_mtime = rootfcb->inode_item.otime = now;
     rootfcb->inode_item.st_gid = GID_NOBODY; // FIXME?
     
-    rootfcb->atts = get_file_attributes(Vcb, &rootfcb->inode_item, rootfcb->subvol, rootfcb->inode, rootfcb->type, FALSE, TRUE, Irp);
+    rootfcb->atts = get_file_attributes(Vcb, rootfcb->subvol, rootfcb->inode, rootfcb->type, FALSE, TRUE, Irp);
     
     SeCaptureSubjectContext(&subjcont);
     
@@ -964,6 +924,12 @@
     
     rootfcb->created = TRUE;
     
+    if (fileref->fcb->inode_item.flags & BTRFS_INODE_COMPRESS)
+        rootfcb->inode_item.flags |= BTRFS_INODE_COMPRESS;
+    
+    rootfcb->prop_compression = fileref->fcb->prop_compression;
+    rootfcb->prop_compression_changed = rootfcb->prop_compression != PropCompression_None;
+    
     r->lastinode = rootfcb->inode;
     
     // add INODE_REF
@@ -980,15 +946,15 @@
     ir->n = strlen(DOTDOT);
     RtlCopyMemory(ir->name, DOTDOT, ir->n);
 
-    if (!insert_tree_item(Vcb, r, r->root_item.objid, TYPE_INODE_REF, r->root_item.objid, ir, irsize, NULL, Irp, &rollback)) {
-        ERR("insert_tree_item failed\n");
-        Status = STATUS_INTERNAL_ERROR;
+    Status = insert_tree_item(Vcb, r, r->root_item.objid, TYPE_INODE_REF, r->root_item.objid, ir, irsize, NULL, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
         goto end;
     }
     
     // create fileref for entry in other subvolume
     
-    fr = create_fileref();
+    fr = create_fileref(Vcb);
     if (!fr) {
         ERR("out of memory\n");
         
@@ -1003,44 +969,10 @@
     fr->fcb = rootfcb;
     
     mark_fcb_dirty(rootfcb);
-    
-    Status = fcb_get_last_dir_index(fcb, &dirpos, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("fcb_get_last_dir_index returned %08x\n", Status);
-        ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
-        free_fileref(fr);
-        ExReleaseResourceLite(&Vcb->fcb_lock);
-        goto end;
-    }
-    
-    fr->index = dirpos;
-    fr->utf8 = utf8;
-    
-    fr->filepart.MaximumLength = fr->filepart.Length = nameus.Length;
-    fr->filepart.Buffer = ExAllocatePoolWithTag(PagedPool, fr->filepart.MaximumLength, ALLOC_TAG);
-    if (!fr->filepart.Buffer) {
-        ERR("out of memory\n");
-        ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
-        free_fileref(fr);
-        ExReleaseResourceLite(&Vcb->fcb_lock);
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end;
-    }
-    
-    RtlCopyMemory(fr->filepart.Buffer, nameus.Buffer, nameus.Length);
-    
-    Status = RtlUpcaseUnicodeString(&fr->filepart_uc, &fr->filepart, TRUE);
-    if (!NT_SUCCESS(Status)) {
-        ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-        ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
-        free_fileref(fr);
-        ExReleaseResourceLite(&Vcb->fcb_lock);
-        goto end;
-    }
-    
+
     fr->parent = fileref;
     
-    Status = add_dir_child(fileref->fcb, r->id, TRUE, dirpos, &utf8, &fr->filepart, &fr->filepart_uc, BTRFS_TYPE_DIRECTORY, &dc);
+    Status = add_dir_child(fileref->fcb, r->id, TRUE, &utf8, &nameus, BTRFS_TYPE_DIRECTORY, &dc);
     if (!NT_SUCCESS(Status))
         WARN("add_dir_child returned %08x\n", Status);
     
@@ -1051,7 +983,7 @@
     if (!fr->fcb->hash_ptrs) {
         ERR("out of memory\n");
         ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
-        free_fileref(fr);
+        free_fileref(Vcb, fr);
         ExReleaseResourceLite(&Vcb->fcb_lock);
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
@@ -1063,7 +995,7 @@
     if (!fcb->hash_ptrs_uc) {
         ERR("out of memory\n");
         ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
-        free_fileref(fr);
+        free_fileref(Vcb, fr);
         ExReleaseResourceLite(&Vcb->fcb_lock);
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
@@ -1071,7 +1003,10 @@
     
     RtlZeroMemory(fr->fcb->hash_ptrs_uc, sizeof(LIST_ENTRY*) * 256);
     
-    insert_fileref_child(fileref, fr, TRUE);
+    ExAcquireResourceExclusiveLite(&fileref->nonpaged->children_lock, TRUE);
+    InsertTailList(&fileref->children, &fr->list_entry);
+    ExReleaseResourceLite(&fileref->nonpaged->children_lock);
+        
     increase_fileref_refcount(fileref);
     
     if (fr->fcb->type == BTRFS_TYPE_DIRECTORY)
@@ -1103,10 +1038,20 @@
     Status = STATUS_SUCCESS;    
     
 end:
-    if (!NT_SUCCESS(Status))
-        do_rollback(Vcb, &rollback);
-    else
-        clear_rollback(Vcb, &rollback);
+    if (!NT_SUCCESS(Status)) {
+        if (fr) {
+            fr->deleted = TRUE;
+            mark_fileref_dirty(fr);
+        } else if (rootfcb) {
+            rootfcb->deleted = TRUE;
+            mark_fcb_dirty(rootfcb);
+        }
+
+        if (r) {
+            RemoveEntryList(&r->list_entry);
+            InsertTailList(&Vcb->drop_roots, &r->list_entry);
+        }
+    }
     
     ExReleaseResourceLite(&Vcb->tree_lock);
     
@@ -1118,7 +1063,7 @@
 end2:
     if (fr) {
         ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
-        free_fileref(fr);
+        free_fileref(Vcb, fr);
         ExReleaseResourceLite(&Vcb->fcb_lock);
     }
         
@@ -1176,18 +1121,18 @@
             extent* ext = CONTAINING_RECORD(le, extent, list_entry);
             
             if (!ext->ignore) {
-                if (ext->data->type == EXTENT_TYPE_INLINE) {
-                    bii->inline_length += ext->data->decoded_size;
+                if (ext->extent_data.type == EXTENT_TYPE_INLINE) {
+                    bii->inline_length += ext->extent_data.decoded_size;
                 } else {
-                    EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->data->data;
+                    EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->extent_data.data;
                     
                     // FIXME - compressed extents with a hole in them are counted more than once
                     if (ed2->size != 0) {
-                        if (ext->data->compression == BTRFS_COMPRESSION_NONE) {
+                        if (ext->extent_data.compression == BTRFS_COMPRESSION_NONE) {
                             bii->disk_size[0] += ed2->num_bytes;
-                        } else if (ext->data->compression == BTRFS_COMPRESSION_ZLIB) {
+                        } else if (ext->extent_data.compression == BTRFS_COMPRESSION_ZLIB) {
                             bii->disk_size[1] += ed2->size;
-                        } else if (ext->data->compression == BTRFS_COMPRESSION_LZO) {
+                        } else if (ext->extent_data.compression == BTRFS_COMPRESSION_LZO) {
                             bii->disk_size[2] += ed2->size;
                         }
                     }
@@ -1198,6 +1143,20 @@
         }
     }
     
+    switch (fcb->prop_compression) {
+        case PropCompression_Zlib:
+            bii->compression_type = BTRFS_COMPRESSION_ZLIB;
+        break;
+        
+        case PropCompression_LZO:
+            bii->compression_type = BTRFS_COMPRESSION_LZO;
+        break;
+        
+        default:
+            bii->compression_type = BTRFS_COMPRESSION_ANY;
+        break;
+    }
+    
     ExReleaseResourceLite(fcb->Header.Resource);
     
     return STATUS_SUCCESS;
@@ -1240,6 +1199,14 @@
         return STATUS_ACCESS_DENIED;
     }
     
+    if (bsii->compression_type_changed && bsii->compression_type > BTRFS_COMPRESSION_LZO)
+        return STATUS_INVALID_PARAMETER;
+    
+    if (fcb->subvol->root_item.flags & BTRFS_SUBVOL_READONLY) {
+        WARN("trying to change inode on readonly subvolume\n");
+        return STATUS_ACCESS_DENIED;
+    }
+    
     ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
     
     if (bsii->flags_changed) {
@@ -1307,7 +1274,25 @@
     if (bsii->gid_changed)
         fcb->inode_item.st_gid = bsii->st_gid;
     
-    if (bsii->flags_changed || bsii->mode_changed || bsii->uid_changed || bsii->gid_changed) {
+    if (bsii->compression_type_changed) {
+        switch (bsii->compression_type) {
+            case BTRFS_COMPRESSION_ANY:
+                fcb->prop_compression = PropCompression_None;
+            break;
+            
+            case BTRFS_COMPRESSION_ZLIB:
+                fcb->prop_compression = PropCompression_Zlib;
+            break;
+            
+            case BTRFS_COMPRESSION_LZO:
+                fcb->prop_compression = PropCompression_LZO;
+            break;
+        }
+        
+        fcb->prop_compression_changed = TRUE;
+    }
+    
+    if (bsii->flags_changed || bsii->mode_changed || bsii->uid_changed || bsii->gid_changed || bsii->compression_type_changed) {
         fcb->inode_item_changed = TRUE;
         mark_fcb_dirty(fcb);
     }
@@ -1352,10 +1337,11 @@
         
         dev->next_entry = 0;
         dev->dev_id = dev2->devitem.dev_id;
-        dev->size = dev2->length;
         dev->readonly = (Vcb->readonly || dev2->readonly) ? TRUE : FALSE;
         dev->device_number = dev2->disk_num;
         dev->partition_number = dev2->part_num;
+        dev->size = dev2->devitem.num_bytes;
+        RtlCopyMemory(dev->stats, dev2->stats, sizeof(UINT64) * 5);
         
         length -= sizeof(btrfs_device) - sizeof(WCHAR) + dev->namelen;
         
@@ -1545,7 +1531,7 @@
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS fs_get_statistics(PDEVICE_OBJECT DeviceObject, PFILE_OBJECT FileObject, void* buffer, DWORD buflen, ULONG_PTR* retlen) {
+static NTSTATUS fs_get_statistics(void* buffer, DWORD buflen, ULONG_PTR* retlen) {
     FILESYSTEM_STATISTICS* fss;
     
     WARN("STUB: FSCTL_FILESYSTEM_GET_STATISTICS\n");
@@ -1628,8 +1614,8 @@
         fcb->atts &= ~FILE_ATTRIBUTE_SPARSE_FILE;
         fcb->atts_changed = TRUE;
         
-        defda = get_file_attributes(Vcb, &fcb->inode_item, fcb->subvol, fcb->inode, fcb->type,
-                                    fileref && fileref->filepart.Length > 0 && fileref->filepart.Buffer[0] == '.', TRUE, Irp);
+        defda = get_file_attributes(Vcb, fcb->subvol, fcb->inode, fcb->type,
+                                    fileref && fileref->dc && fileref->dc->name.Length >= sizeof(WCHAR) && fileref->dc->name.Buffer[0] == '.', TRUE, Irp);
         
         fcb->atts_deleted = defda == fcb->atts;
     }
@@ -1655,10 +1641,10 @@
     if (compress) {
         start_data = start & ~(UINT64)(COMPRESSED_EXTENT_SIZE - 1);
         end_data = min(sector_align(start + length, COMPRESSED_EXTENT_SIZE),
-                       sector_align(fcb->inode_item.st_size, fcb->Vcb->superblock.sector_size));
+                       sector_align(fcb->inode_item.st_size, Vcb->superblock.sector_size));
     } else {
-        start_data = start & ~(UINT64)(fcb->Vcb->superblock.sector_size - 1);
-        end_data = sector_align(start + length, fcb->Vcb->superblock.sector_size);
+        start_data = start & ~(UINT64)(Vcb->superblock.sector_size - 1);
+        end_data = sector_align(start + length, Vcb->superblock.sector_size);
     }
 
     data = ExAllocatePoolWithTag(PagedPool, end_data - start_data, ALLOC_TAG);
@@ -1670,7 +1656,7 @@
     RtlZeroMemory(data, end_data - start_data);
     
     if (start > start_data || start + length < end_data) {
-        Status = read_file(fcb, data, start_data, end_data - start_data, NULL, Irp, TRUE);
+        Status = read_file(fcb, data, start_data, end_data - start_data, NULL, Irp);
         
         if (!NT_SUCCESS(Status)) {
             ERR("read_file returned %08x\n", Status);
@@ -1691,7 +1677,7 @@
             return Status;
         }
     } else {
-        Status = do_write_file(fcb, start_data, end_data, data, Irp, rollback);
+        Status = do_write_file(fcb, start_data, end_data, data, Irp, FALSE, 0, rollback);
         
         ExFreePool(data);
         
@@ -1798,7 +1784,7 @@
         goto end;
     }
     
-    if (ext->datalen >= sizeof(EXTENT_DATA) && ext->data->type == EXTENT_TYPE_INLINE) {
+    if (ext->extent_data.type == EXTENT_TYPE_INLINE) {
         Status = zero_data(Vcb, fcb, fzdi->FileOffset.QuadPart, fzdi->BeyondFinalZero.QuadPart - fzdi->FileOffset.QuadPart, Irp, &rollback);
         if (!NT_SUCCESS(Status)) {
             ERR("zero_data returned %08x\n", Status);
@@ -1874,7 +1860,7 @@
     if (!NT_SUCCESS(Status))
         do_rollback(Vcb, &rollback);
     else
-        clear_rollback(Vcb, &rollback);
+        clear_rollback(&rollback);
     
     ExReleaseResourceLite(fcb->Header.Resource);
     ExReleaseResourceLite(&Vcb->tree_lock);
@@ -1882,7 +1868,7 @@
     return Status;
 }
 
-static NTSTATUS query_ranges(device_extension* Vcb, PFILE_OBJECT FileObject, FILE_ALLOCATED_RANGE_BUFFER* inbuf, ULONG inbuflen, void* outbuf, ULONG outbuflen, ULONG_PTR* retlen) {
+static NTSTATUS query_ranges(PFILE_OBJECT FileObject, FILE_ALLOCATED_RANGE_BUFFER* inbuf, ULONG inbuflen, void* outbuf, ULONG outbuflen, ULONG_PTR* retlen) {
     NTSTATUS Status;
     fcb* fcb;
     LIST_ENTRY* le;
@@ -1936,8 +1922,8 @@
         extent* ext = CONTAINING_RECORD(le, extent, list_entry);
         
         if (!ext->ignore) {
-            EXTENT_DATA2* ed2 = (ext->data->type == EXTENT_TYPE_REGULAR || ext->data->type == EXTENT_TYPE_PREALLOC) ? (EXTENT_DATA2*)ext->data->data : NULL;
-            UINT64 len = ed2 ? ed2->num_bytes : ext->data->decoded_size;
+            EXTENT_DATA2* ed2 = (ext->extent_data.type == EXTENT_TYPE_REGULAR || ext->extent_data.type == EXTENT_TYPE_PREALLOC) ? (EXTENT_DATA2*)ext->extent_data.data : NULL;
+            UINT64 len = ed2 ? ed2->num_bytes : ext->extent_data.decoded_size;
             
             if (ext->offset > last_end) { // first extent after a hole
                 if (last_end > last_start) {
@@ -2033,12 +2019,21 @@
 static NTSTATUS lock_volume(device_extension* Vcb, PIRP Irp) {
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     NTSTATUS Status;
-    LIST_ENTRY rollback;
     KIRQL irql;
     BOOL lock_paused_balance = FALSE;
     
     TRACE("FSCTL_LOCK_VOLUME\n");
     
+    if (Vcb->scrub.thread) {
+        WARN("cannot lock while scrub running\n");
+        return STATUS_DEVICE_NOT_READY;
+    }
+    
+    if (Vcb->balance.thread) {
+        WARN("cannot lock while balance running\n");
+        return STATUS_DEVICE_NOT_READY;
+    }
+    
     TRACE("locking volume\n");
     
     FsRtlNotifyVolumeEvent(IrpSp->FileObject, FSRTL_VOLUME_LOCK);
@@ -2056,8 +2051,6 @@
     
     ExReleaseResourceLite(&Vcb->fcb_lock);
     
-    InitializeListHead(&rollback);
-    
     if (Vcb->balance.thread && KeReadStateEvent(&Vcb->balance.event)) {
         ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
         KeClearEvent(&Vcb->balance.event);
@@ -2071,14 +2064,19 @@
     flush_fcb_caches(Vcb);
     
     if (Vcb->need_write && !Vcb->readonly)
-        do_write(Vcb, Irp, &rollback);
+        Status = do_write(Vcb, Irp);
+    else
+        Status = STATUS_SUCCESS;
     
     free_trees(Vcb);
     
-    clear_rollback(Vcb, &rollback);
-    
     ExReleaseResourceLite(&Vcb->tree_lock);
     
+    if (!NT_SUCCESS(Status)) {
+        ERR("do_write returned %08x\n", Status);
+        goto end;
+    }
+    
     IoAcquireVpbSpinLock(&irql);
 
     if (!(Vcb->Vpb->Flags & VPB_LOCKED)) { 
@@ -2191,7 +2189,6 @@
                 KIRQL irql;
                 PVPB newvpb;
                 BOOL free_newvpb = FALSE;
-                LIST_ENTRY rollback;
                 
                 newvpb = ExAllocatePoolWithTag(NonPagedPool, sizeof(VPB), ALLOC_TAG);
                 if (!newvpb) {
@@ -2206,8 +2203,6 @@
                 devobj->Vpb->Flags &= ~VPB_MOUNTED;
                 IoReleaseVpbSpinLock(irql);
                 
-                InitializeListHead(&rollback);
-                
                 ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
                 
                 Vcb->removing = TRUE;
